/*
This demo code for leonado
ona   RelabA ON
offa  RelayA OFF
*/
String msg = String("");
int SmsContentFlag = 0;
int RelayA = 7;
void setup()
{
  Serial1.begin(115200); // the A6 baud rate   
  Serial.begin(115200);  
  pinMode(4, OUTPUT);  //POWER OFF PIN    Active High
  pinMode(5, OUTPUT);  //SLEEP PIN        Active LOW
  pinMode(8,OUTPUT);   //POWER ON PIN     Active High
  digitalWrite(5, HIGH); 
  digitalWrite(4, LOW); 
  digitalWrite(8, LOW); 
  // Initialize la PIN
  pinMode( RelayA, OUTPUT ); 
  digitalWrite( RelayA, LOW ); 
  GprsTextModeSMS();
  poweron();
}
 
void loop()
{
    char SerialInByte;
    if(Serial.available())
    {
       Serial1.print((unsigned char)Serial.read());
    }  
    else if(Serial1.available())
    {
        char SerialInByte;
        SerialInByte = (unsigned char)Serial1.read();
//        Serial.print( SerialInByte );
        if( SerialInByte == 13 )
        {
          ProcessGprsMsg();
         }
         if( SerialInByte == 10 ){
            // EN: Skip Line feed
         }
         else {
           // EN: store the current character in the message string buffer
           msg += String(SerialInByte);
         }
     }   
}
 
// EN: Make action based on the content of the SMS. 
//     Notice than SMS content is the result of the processing of several GPRS shield messages.
void poweron()
{
     boolean result = false;
     digitalWrite(8, HIGH); 
     delay(3000);       
     digitalWrite(8, LOW);
     Serial1.flush();
     Serial1.setTimeout(3000);
     Serial1.println("AT");
     result = Serial1.find("OK");
     if(result)
	 Serial.println( "Please send sms to control your device!" );
    else
	{
             Serial.println( "Failed to power on A6!" );
             while(1);
	}
}
void ProcessSms( String sms )
{
  Serial.print( "ProcessSms for [" );
  Serial.print( sms );
  Serial.println( "]" );
 
  if( sms.indexOf("ona") >= 0 ){
    digitalWrite( RelayA, HIGH );
    Serial.println( "RelayA ON" );
//    return;
  }
    if( sms.indexOf("offa") >= 0 ){
        digitalWrite( RelayA, LOW );
    Serial.println( "RelayA OFF" );
//    return;
  }
}

// EN: Request Text Mode for SMS messaging

void GprsTextModeSMS(){
  Serial1.println( "AT+CMGF=1" );
}
 
void GprsReadSmsStore( String SmsStorePos ){
  // Serial.print( "GprsReadSmsStore for storePos " );
  // Serial.println( SmsStorePos ); 
  Serial1.print( "AT+CMGR=" );
  Serial1.println( SmsStorePos );
}
 
// EN: Clear the GPRS shield message buffer

void ClearGprsMsg(){
  msg = "";
}
 
// EN: interpret the GPRS shield message and act appropiately

void ProcessGprsMsg() 
{
    Serial.println("");
    Serial.print( "GPRS Message: [" );
    Serial.print( msg );
    Serial.println( "]" );
    if( msg.indexOf( "Call Ready" ) >= 0 )
   {
       Serial.println( "*** GPRS Shield registered on Mobile Network ***" );
       GprsTextModeSMS();
   }
 
  // EN: unsolicited message received when getting a SMS message
  // FR: Message non sollicité quand un SMS arrive
  if( msg.indexOf( "+CIEV" ) >= 0 )
  {
     Serial.println( "*** SMS Received ***" );
  }
 
  // EN: SMS store readed through UART (result of GprsReadSmsStore request)  
  if( msg.indexOf( "+CMT:" ) >= 0 )
  {
    // EN: Next message will contains the BODY of SMS
    SmsContentFlag = 1;
    // EN: Following lines are essentiel to not clear the flag!
    ClearGprsMsg();
    return;
  }
 
  // EN: +CMGR message just before indicate that the following GRPS Shield message 
  //     (this message) will contains the SMS body

  if( SmsContentFlag == 1 )
  {
    Serial.println( "*** SMS MESSAGE CONTENT ***" );
    Serial.println( msg );
    Serial.println( "*** END OF SMS MESSAGE ***" );
    ProcessSms( msg );
  }
 
  ClearGprsMsg();
  // EN: Always clear the flag
  SmsContentFlag = 0; 
}
